(function ($, Drupal) {
  Drupal.behaviors.media_folder_droppable = {
    attach(context) {
      $(
        once('media-file-explorer-droppable', '#subfolders .folder', context),
      ).each(function () {
        $(this).draggable({
          revert: 'invalid',
          appendTo: 'body',
          containment: '#explorer',
          scroll: false,
          cursor: 'move',
          helper: 'clone',
          cursorAt: { top: 40, left: 20 },
        });

        if ($(this).hasClass('folder-folder')) {
          $(this).droppable({
            accept: '#subfolders .folder',
            classes: {
              'ui-droppable-active': 'droppable move-droppable',
            },
            drop(event, ui) {
              const draggable = $(ui.draggable);
              const target = $(event.currentTarget);
              const fid = target.attr('data-id');
              const mid = draggable.attr('data-id');
              const type = draggable.hasClass('folder-file')
                ? 'file'
                : 'folder';

              $(this).ajaxMove(fid, mid, type);
            },
          });
        }
      });

      $(
        once(
          'media-file-navbar-droppable',
          '#navbar div.navbar-folder',
          context,
        ),
      ).each(function () {
        $(this).droppable({
          accept: '#subfolders .folder',
          classes: {
            'ui-droppable-active': 'droppable move-droppable',
          },
          drop(event, ui) {
            const draggable = $(ui.draggable);
            const target = $(event.target);
            const fid = target.attr('data-id');
            const mid = draggable.attr('data-id');
            const type = draggable.hasClass('folder-file') ? 'file' : 'folder';

            $(this).ajaxMove(fid, mid, type);
          },
        });
      });
    },
  };
})(jQuery, Drupal);
